//
//  YKLookClassLoader
//
//  Copyright (c) 2009-2010 YorozuKotowariYa Ltd.
//
//
package jp.co.yorozukotowariya.yklook;

import java.io.*;


class YKLookClassLoader extends ClassLoader
{
	YKLookCommon ykvCommon  = null;
	String       ykvRawData = null;

	YKLookClassLoader( YKLookCommon prmCommon )
	{
		ykvCommon = prmCommon;
	}

	void ykmSetRawData( String prmRawData )
	{
		ykvRawData = prmRawData;
	}

	public Class findClass( String prmName ) throws ClassNotFoundException
	{
		byte[] buf;

		if( ykvRawData == null )
			buf = ykmRemote( prmName );
		else
			buf = YKLookCommon.ykmDecodeFromHex( ykvRawData );

		if( buf.length == 0 )
		{
			throw new ClassNotFoundException( prmName );
		}
		return defineClass( prmName, buf, 0, buf.length );
	}
	byte[] ykmRemote( String prmName ) throws ClassNotFoundException
	{
		int         pos;
		String      path;
		InputStream is = null;
		byte[]      buf;

		try
		{
			pos  = prmName.lastIndexOf( "." );
			path = prmName.substring( pos + 1 ) + ".class";
			is   = ykvCommon.ykvImpl.ykmGetCodeAsStream( path );
			buf  = YKLookCommon.ykmLoadBytes( is );
		}
		catch( YKLookException ex )
		{
			throw new ClassNotFoundException( ex.toString() );
		}
		catch( IOException ex )
		{
			throw new ClassNotFoundException( ex.toString() );
		}
		finally
		{
			try
			{
				if( is != null )
					is.close();
			}
			catch( IOException ex )
			{
				throw new ClassNotFoundException( ex.toString() );
			}
		}
		return buf;
	}
}

//
// end of program
//
