//
//  YKLookCommon
//
//  Copyright (c) 2009-2010 YorozuKotowariYa Ltd.
//
//
package jp.co.yorozukotowariya.yklook;

import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;


class YKLookCommon
{
	static final String ykvMsgErrServer =
								"\u30b5\u30fc\u30d0\u5074\u306e"       +
								"\u30d7\u30ed\u30b0\u30e9\u30e0\u3067" +
								"\u30a8\u30e9\u30fc\u304c\u767a\u751f" +
								"\u3057\u307e\u3057\u305f\u3002";
	static final String ykvMsgErrInput =
								"\u5165\u529b\u7981\u6b62\u6587\u5b57" +
								"\u304c\u542b\u307e\u308c\u3066"       +
								"\u3044\u307e\u3059\u3002"      + "\n" +
								"\u5165\u529b\u3092"                   +
								"\u3084\u308a\u306a\u304a\u3057\u3066" +
								"\u304f\u3060\u3055\u3044\u3002";

	String             ykvSelfId;
	String             ykvUserId;
	YKLookCommonIF     ykvImpl;
	String             ykvEncoding;
	YKLookEncodingBase ykvEncObj  = null;
	YKLookClassLoader  ykvLoader  = null;
	String             ykvError   = null;
	StringBuffer       ykvLogBuf  = new StringBuffer();
	HashMap            ykvObjects = new HashMap();
	HashMap            ykvNotification = new HashMap();
	String[]           ykvMsgErrEncoding = new String[5];

	String   ykvDialogCB;
	boolean  ykvDialogCBall;
	int      ykvDialogCBframe;
	Object[] ykvDialogGui;
	String   ykvDialogTitle;
	int      ykvDialogMsgType;
	int      ykvDialogOptType;
	Icon     ykvDialogIcon;
	String[] ykvDialogOption;
	String   ykvDialogDefault;

	YKLookCommon( String prmSelfId, String prmUserId, YKLookCommonIF prmImpl )
	{
		ykvSelfId = prmSelfId;
		ykvUserId = prmUserId;
		ykvImpl   = prmImpl;

		ykvObjects.put( new Integer(0), this );

		ykvMsgErrEncoding[0] =  // description
				"\u4ee5\u4e0b\u306e\u6587\u5b57\u306f"                         +
				"\u304a\u4f7f\u3044\u306b\u306a\u308c\u307e\u305b\u3093\u3002" +
				"\u5225\u306e\u6587\u5b57\u3067"                               +
				"\u7f6e\u304d\u63db\u3048\u3066\u304f\u3060\u3055\u3044\u3002";
		ykvMsgErrEncoding[1] =  // encoding
				"\u6587\u5b57\u7b26\u53f7\u5316\u65b9\u6cd5\uff1a";
		ykvMsgErrEncoding[2] =  // char
				"\u4f7f\u7528\u5236\u9650\u6587\u5b57\uff1a";
		ykvMsgErrEncoding[3] =  // code(10)
				"\u30e6\u30cb\u30b3\u30fc\u30c9\u6587\u5b57\u756a\u53f7" +
				"\uff08\u0031\u0030\u9032\u6570\u8868\u8a18\uff09\uff1a";
		ykvMsgErrEncoding[4] =  // code(16)
				"\u30e6\u30cb\u30b3\u30fc\u30c9\u6587\u5b57\u756a\u53f7" +
				"\uff08\u0031\u0036\u9032\u6570\u8868\u8a18\uff09\uff1a";
	}

	void ykmSetClassLoader( String prmRawData )
	{
		if( ykvLoader == null )
			ykvLoader = new YKLookClassLoader( this );

		ykvLoader.ykmSetRawData( prmRawData );
	}
	void ykmSetEncoding()
	{
		String enc = ykvImpl.ykmGetParameter( "YKLook_encoding" );
		Class  cls;

		if( enc == null || enc.length() == 0 )
			ykvEncoding = "ISO8859_1";
		else
			ykvEncoding = enc;

		if( ykvEncoding.startsWith("YKLook_") )
		{
			try
			{
				ykmSetClassLoader( null );
				cls = ykvLoader.loadClass( "jp.co.yorozukotowariya.yklook." +
											ykvEncoding );
				//cls = Class.forName( "jp.co.yorozukotowariya.yklook." +
				//					ykvEncoding );
				ykvEncObj = (YKLookEncodingBase) cls.newInstance();
			}
			catch( Exception ex )
			{
				ykvEncoding = "SJIS";
				//throw new YKLookException( ex.getMessage() );
			}
		}
	}
	void ykmSetLookAndFeel()
	{
		String laf = ykvImpl.ykmGetParameter( "YKLook_laf" );
		String nam;
		String tok;
		StringTokenizer st;
		Component co = ykvImpl.ykmRootPaneContainer().getContentPane();

		if( laf == null || laf.length() == 0 )
			return;
		st = new StringTokenizer( laf, " :" );
		while( st.hasMoreTokens() )
		{
			nam = null;
			tok = st.nextToken();
			if( tok.equalsIgnoreCase( "YKLook_laf_System" ) )
				nam = UIManager.getSystemLookAndFeelClassName();
			if( tok.equalsIgnoreCase( "YKLook_laf_CrossPlatform" ) )
				nam = UIManager.getCrossPlatformLookAndFeelClassName();
			if( nam == null )
				nam = tok;
			try
			{
				UIManager.setLookAndFeel( nam );
				SwingUtilities.updateComponentTreeUI( co );
				return;
			}
			catch( Exception ex )
			{
				// no throw.
				// ignore exception. (^_^)v
			}
		}
	}

	String ykmGetParamMessage( String prmKey, String prmAlt )
	{
		String param = ykvImpl.ykmGetParameter( prmKey );

		if( param == null || param.length() < 1 )
			return prmAlt;

		param = ykmEncodingFrom( ykmDecodeFromHex( param ) );

		if( param == null || param.length() < 1 )
			return prmAlt;

		return param;
	}
	void ykmShowEncodingErrorDialog( String prmText )
	{
		String[] msg = new String[5];  // desc, enc, char, code(10), code(16)
		String[] inf = new String[3];  // char, code(10), code(16)

		ykmCheckEncodingError( prmText, inf );

		msg[0] = ykmGetParamMessage( "YKLook_errorEncoding_1",
										ykvMsgErrEncoding[0] );
		msg[1] = ykmGetParamMessage( "YKLook_errorEncoding_2",
										ykvMsgErrEncoding[1] ) + ykvEncoding;
		msg[2] = ykmGetParamMessage( "YKLook_errorEncoding_3",
										ykvMsgErrEncoding[2] ) + inf[0];
		msg[3] = ykmGetParamMessage( "YKLook_errorEncoding_4",
										ykvMsgErrEncoding[3] ) + inf[1];
		msg[4] = ykmGetParamMessage( "YKLook_errorEncoding_5",
										ykvMsgErrEncoding[4] ) + inf[2];

		JOptionPane.showMessageDialog( null, msg, "alert",
										JOptionPane.ERROR_MESSAGE );
	}
	void ykmCheckEncodingError( String prmText, String[] prmInfo )
	{
		BreakIterator bi     = BreakIterator.getCharacterInstance();
		String        subStr = null;
		StringBuffer  buf10  = new StringBuffer();
		StringBuffer  buf16  = new StringBuffer();
		char[]        ca;
		int           stPos, enPos, idx;

		bi.setText(prmText);
		stPos = bi.first();
		enPos = bi.next();
		while( enPos != BreakIterator.DONE )
		{
			subStr = prmText.substring( stPos, enPos );
			try
			{
				ykmEncodingTo( subStr );
			}
			catch( Exception ex )
			{
				break;
			}
			stPos = enPos;
			enPos = bi.next();
		}
		if( subStr == null || enPos == BreakIterator.DONE )
		{
			prmInfo[0] = "(nothing)";
			prmInfo[1] = "";
			prmInfo[2] = "";
			return;
		}
		ca = subStr.toCharArray();
		for( idx = 0; idx < ca.length; idx++ )
		{
			if( idx > 0 )
			{
				buf10.append( ", " );
				buf16.append( ", " );
			}
			buf10.append( Integer.toString   ( ca[idx] ) );
			buf16.append( Integer.toHexString( ca[idx] ) );
		}
		prmInfo[0] = subStr;
		prmInfo[1] = buf10.toString();
		prmInfo[2] = buf16.toString();
	}

	void ykmCorrespond( String prmEvent )
	{
		String gui,txt,ans;
		String msg = null;

		try
		{
			if( prmEvent == null )  // first display
			{
				gui = ykmMainInfo();
				txt = "yks=" + ykvSelfId +
						"&yku=" + ykvUserId +
						"&ykg=" + gui;
			}
			else
			{
				gui = ykmMakeGuiInfo();
				txt = "yks=" + ykvSelfId +
						"&yku=" + ykvUserId +
						"&ykg=" + gui +
						"&yke=" + prmEvent;
			}
			ans = ykvImpl.ykmCommunicate( txt );
			ykmExecuteScheme( ans );
		}
		catch( YKLookExceptionEncoding ex )
		{
			// nothing
		}
		catch( IOException ex )  // enable retry
		{
			msg = "Maybe Error.\n" + ex.toString() + "\n\nretry, please.";
		}
		catch( YKLookException ex )  // fatal error. never retry
		{
			msg = ykvError = ex.toString();
		}
		catch( Exception ex )  // fatal error. never retry
		{
			msg = ykvError = "Error\n" + ex.toString() + "\n\n" + ykmStack(ex);
		}

		if( msg != null )  // error
		{
			JOptionPane.showMessageDialog( null, msg, "alert",
											JOptionPane.ERROR_MESSAGE );
			return;
		}
	}
	static final String ykvMainInfo[] =
						{
							"java.class.version",
							"java.vendor",
							"java.vendor.url",
							"java.version",
							"os.arch",
							"os.name",
							"os.version"
						};

	String ykmMainInfo()
			throws UnsupportedEncodingException, YKLookException
	{
		String       val, hex;
		StringBuffer buf = new StringBuffer("0");
		Toolkit      tk  = Toolkit.getDefaultToolkit();
		Dimension    dim = tk.getScreenSize();
		int          w   = (int) dim.getWidth();
		int          h   = (int) dim.getHeight();
		int          idx;

		for( idx = ykvMainInfo.length - 1; idx >= 0; idx-- )
		{
			val = System.getProperty( ykvMainInfo[idx] );
			hex = ykmDecodeToHex( ykmEncodingTo( val ) );
			buf.append( ":S." + ykvMainInfo[idx] + ":" + hex );
		}
		buf.append(":i.screen.width:" + w + ":i.screen.height:" + h + ":end:");
		return buf.toString();
	}
	String ykmMakeGuiInfo() throws YKLookExceptionEncoding
	{
		Iterator     it = ykvObjects.values().iterator();
		Object       obj;
		StringBuffer buf = new StringBuffer();

		while( it.hasNext() )
		{
			obj = it.next();
			if( obj instanceof YKLookDumpIF )
				((YKLookDumpIF) obj).ykmDumpGuiInfo( buf );
		}
		if( buf.length() > 0 )
			return buf.toString();

		return "empty";
	}
	String ykmRecvAnswer( BufferedReader prmBr )
			throws IOException, YKLookException
	{
		String hdr;
		String ans;

		hdr = prmBr.readLine();
		if( hdr == null )
		{
			ans = ykmGetParamMessage( "YKLook_errorServer", ykvMsgErrServer );
			throw new YKLookException( ans );
		}

		ans = prmBr.readLine();
		if( hdr.equalsIgnoreCase("yklook-answer") )
			return ans;

		// error
		if( hdr.equalsIgnoreCase("yklook-error") )
		{
			if( ans == null )
				ans = "Error: Empty Answer";
			else
				ans = ykmEncodingFrom( ykmDecodeFromHex( ans ) );
		}
		else
		{
			ans = ykmGetParamMessage( "YKLook_errorServer", ykvMsgErrServer );
		}
		throw new YKLookException( ans );
	}
	void ykmExecuteScheme( String prmScheme )
			throws NoSuchMethodException, IllegalAccessException,
					InvocationTargetException
	{
		StringTokenizer st  = new StringTokenizer( prmScheme, "\r\n:" );
		Class[]         pts = new Class[] { StringTokenizer.class };
		Object[]        arg = new Object[] { st };
		String          tok;
		Method          met;
		Integer         id;
		Boolean         pas;
		Object          gui;

		while( st.hasMoreTokens() )
		{
			try
			{
				tok = st.nextToken();
				id  = new Integer( tok );
			}
			catch( Exception ex )
			{
				//  no action.   (-_-;
				//  fatal error.
				return;
			}
			gui = ykvObjects.get( id );
			if( gui == null )
				continue;
			if( st.hasMoreTokens() )
			{
				tok = st.nextToken();
				try
				{
					met = gui.getClass().getMethod( tok, pts );
					pas = (Boolean) met.invoke( gui, arg );
				}
				catch( Exception ex )
				{
					//  no action.   (^_^)v
					//  ignore error.
					pas = new Boolean(true);
				}
				if( pas.booleanValue() )
				{
					while( st.hasMoreTokens() )  // need scan for 'end'
					{
						tok = st.nextToken();
						if( tok.equals( "end" ) )
							break;
					}
				}
			}
		}
	}

	static final String[] ykvColorString = { "htmlaqua"   , "htmlblack"  ,
								"htmlblue"   , "htmlfuchsia", "htmlgray"   ,
								"htmlgrey"   , "htmlgreen"  , "htmllime"   ,
								"htmlmaroon" , "htmlnavy"   , "htmlolive"  ,
								"htmlpurple" , "htmlred"    , "htmlsilver" ,
								"htmlteal"   , "htmlyellow" , "htmlwhite"  };
	static final int[] ykvColorInt = { 0x0000ffff, 0x00000000,
								0x000000ff, 0x00ff00ff, 0x00808080,
								0x00808080, 0x00008000, 0x0000ff00,
								0x00800000, 0x00000080, 0x00808000,
								0x00800080, 0x00ff0000, 0x00c0c0c0,
								0x00008080, 0x00ffff00, 0x00ffffff };

	Color ykmDecodeColor( String prmData )
	{
		StringTokenizer st  = new StringTokenizer( prmData, "/" );
		String          typ = st.nextToken();
		String          tok = st.nextToken();
		YKLookColor     ykc;
		Color           col;

		switch( typ.charAt(0) )
		{
			case 'o':
					ykc = (YKLookColor) ykmFindObjectFromId( tok );
					return ykc.ykvSelf;
			case 's':
					return ykmDecodeColorString( tok );
			case 'h':
					return ykmDecodeColorHex( tok );
			case 'i':
					return ykmDecodeColorInt( tok, st );
			case 'f':
					return ykmDecodeColorFloat( tok, st );
			case 'b':
					return ykmDecodeColorBrightness( tok, st );
			//case 'n':
			//		return Color.black;
		}
		return Color.black;
	}
	Color ykmDecodeColorBrightness( String prmVal,
									StringTokenizer prmStrTok )
	{
		YKLookColor ykc = (YKLookColor) ykmFindObjectFromId( prmVal );
		char        chr = prmStrTok.nextToken().charAt(0);
		int         cnt = Integer.parseInt( prmStrTok.nextToken() );
		Color       col = ykc.ykvSelf;
		boolean     mod = (chr == 'd' || chr == 'D');
		int         idx;

		for( idx = 0; idx < cnt; idx++ )
		{
			col = mod ? col.darker() : col.brighter();
		}
		return col;
	}
	Color ykmDecodeColorFloat( String prmVal, StringTokenizer prmStrTok )
	{
		float r = Float.parseFloat( prmVal );
		float g = Float.parseFloat( prmStrTok.nextToken() );
		float b = Float.parseFloat( prmStrTok.nextToken() );
		float a = Float.parseFloat( prmStrTok.nextToken() );

		return new Color( r, g, b, a );
	}
	Color ykmDecodeColorInt( String prmVal, StringTokenizer prmStrTok )
	{
		int r = Integer.parseInt( prmVal );
		int g = Integer.parseInt( prmStrTok.nextToken() );
		int b = Integer.parseInt( prmStrTok.nextToken() );
		int a = Integer.parseInt( prmStrTok.nextToken() );

		return new Color( r, g, b, a );
	}
	Color ykmDecodeColorHex( String prmVal )
	{
		int r,g,b,a;

		r = Integer.parseInt( prmVal.substring(0,2), 16 ) & 0x00ff;
		g = Integer.parseInt( prmVal.substring(2,4), 16 ) & 0x00ff;
		b = Integer.parseInt( prmVal.substring(4,6), 16 ) & 0x00ff;

		if( prmVal.length() == 8 )
			a = Integer.parseInt( prmVal.substring(6), 16 ) & 0x00ff;
		else
			a = 255;

		return new Color( r, g, b, a );
	}
	Color ykmDecodeColorString( String prmColor )
	{
		String col = prmColor.toLowerCase();
		int    idx;

		if( col.equals("white"    ) ) return Color.white    ;
		if( col.equals("lightgray") ) return Color.lightGray;
		if( col.equals("lightgrey") ) return Color.lightGray;
		if( col.equals("gray"     ) ) return Color.gray     ;
		if( col.equals("grey"     ) ) return Color.gray     ;
		if( col.equals("darkgray" ) ) return Color.darkGray ;
		if( col.equals("darkgrey" ) ) return Color.darkGray ;
		if( col.equals("black"    ) ) return Color.black    ;
		if( col.equals("red"      ) ) return Color.red      ;
		if( col.equals("pink"     ) ) return Color.pink     ;
		if( col.equals("orange"   ) ) return Color.orange   ;
		if( col.equals("yellow"   ) ) return Color.yellow   ;
		if( col.equals("green"    ) ) return Color.green    ;
		if( col.equals("magenta"  ) ) return Color.magenta  ;
		if( col.equals("cyan"     ) ) return Color.cyan     ;
		if( col.equals("blue"     ) ) return Color.blue     ;

		for( idx = 0; idx < ykvColorInt.length; idx++ )
		{
			if( col.equals( ykvColorString[idx] ) )
				return new Color( ykvColorInt[idx] );
		}
		return Color.black;
	}
	Object[] ykmDecodeAny( StringTokenizer prmStrTok )
	{
		int      len = Integer.parseInt( prmStrTok.nextToken() );
		int      idx;
		Object[] ary = new Object[len];
		Object   obj;
		String   tok, str;

		for( idx = 0; idx < len; idx++ )
		{
			tok = prmStrTok.nextToken();
			str = tok.substring(2);
			switch( tok.charAt(0) )
			{
				case 'S':
						ary[idx] = ykmEncodingFrom( ykmDecodeFromHex( str ) );
						break;
				case 'i':
						ary[idx] = new Integer( str );
						break;
				case 'f':
						ary[idx] = new Double( str );
						break;
				case 'n':
						ary[idx] = null;
						break;
				case 's':
						ary[idx] =
							str.equals("true") ? Boolean.TRUE : Boolean.FALSE;
						break;
				case 'o':
						obj = ykmFindObjectFromId( str );
						if( obj instanceof YKLookElement )
							ary[idx] = ((YKLookElement) obj).ykmComponent();
						else
							if( obj instanceof YKLookImage )
								ary[idx] = ((YKLookImage) obj).ykvSelf;
							else
								ary[idx] = "";
						break;
				default:
						ary[idx] = "";
						break;
			}
		}
		return ary;
	}

	static byte[] ykmDecodeFromHex( String prmHex )
	{
		char[] hex;
		byte[] wrk;
		int hIdx, wIdx, hi, lo;

		if( prmHex == null )
			return null;
		if( prmHex.equalsIgnoreCase("null") )
			return null;
		if( prmHex.equalsIgnoreCase("empty") )
			return new byte[0];

		hex = prmHex.toCharArray();
		if( (hex.length % 2) != 0 )
		{
			return new byte[] { 0x3f };  // '?'
		}
		wrk = new byte[ hex.length / 2 ];
		for( hIdx = 0, wIdx = 0; hIdx < hex.length; hIdx += 2, wIdx++ )
		{
			hi = hex[hIdx  ] - 0x30;
			lo = hex[hIdx+1] - 0x30;
			if( hi > 9 )
				hi -= 7;
			if( hi > 15 )
				hi -= 0x20;
			if( lo > 9 )
				lo -= 7;
			if( lo > 15 )
				lo -= 0x20;
			wrk[wIdx] = (byte)((hi << 4) | lo);
		}
		return wrk;
	}
	static String ykmDecodeToHex( byte[] prmData )
	{
		char[] wrk;
		int    idx, cnt, hi, lo;

		if( prmData == null )
			return "null";
		if( prmData.length < 1 )
			return "empty";

		wrk = new char[ prmData.length * 2 ];
		for( idx = 0, cnt = 0; idx < prmData.length; idx++, cnt += 2 )
		{
			hi = (prmData[idx] >> 4) & 0x0f;
			lo =  prmData[idx]       & 0x0f;
			wrk[cnt  ] = (char)( (hi <= 9) ? (hi + 0x30) : (hi + 0x37) );
			wrk[cnt+1] = (char)( (lo <= 9) ? (lo + 0x30) : (lo + 0x37) );
		}
		return new String(wrk);
	}
	String ykmEncodingFrom( byte[] prmData )
	{
		if( prmData == null )
			return null;

		if( ykvEncObj != null )
		{
			return ykvEncObj.ykmEncodingFrom( prmData );
		}

		try
		{
			return new String( prmData, ykvEncoding );
		}
		catch( UnsupportedEncodingException ex )
		{
			// nothing
		}
		return "?";
	}
	byte[] ykmEncodingTo( String prmStr )
			throws UnsupportedEncodingException, YKLookException
	{
		if( prmStr == null )
			return null;
		if( prmStr.length() < 1 )
			return new byte[0];

		if( ykvEncObj != null )
		{
			return ykvEncObj.ykmEncodingTo( prmStr );
		}
		return prmStr.getBytes( ykvEncoding );
	}
	String ykmDumpPassword( char[] prmChar ) throws YKLookExceptionEncoding
	{
		byte[] b = new byte[ prmChar.length ];
		String s;
		int    i;

		try
		{
			for( i = 0; i < b.length; i++ )
			{
				if( prmChar[i] == 0x5c || prmChar[i] == 0x7e ||
					prmChar[i] < 0x20 || 0x7e < prmChar[i] )
				{
					s = ykmGetParamMessage( "YKLook_errorInput",
												ykvMsgErrInput );
					JOptionPane.showMessageDialog( null, s, "alert",
											JOptionPane.ERROR_MESSAGE );
					throw new YKLookExceptionEncoding();
				}
				b[i] = (byte) prmChar[i];
			}
			s = ykmDecodeToHex( b );
		}
		finally
		{
			for( i = 0; i < b.length; i++ )
			{
				b[i] = 0;
			}
		}
		return s;
	}
	static int ykmNextInt( StringTokenizer prmStrTok )
	{
		String str = prmStrTok.nextToken();
		char   chr = str.charAt(0);

		if( chr == 'N' || chr == 'n' || chr == 'E' || chr == 'e' )
			return Integer.MIN_VALUE;

		return Integer.parseInt( str );
	}
	String ykmNextString( StringTokenizer prmStrTok )
	{
		String  hex = prmStrTok.nextToken();
		byte[]  bin = ykmDecodeFromHex( hex );

		return ykmEncodingFrom( bin );
	}
	String ykmDumpString( String prmString )
			throws YKLookExceptionEncoding
	{
		try
		{
			return ykmDecodeToHex( ykmEncodingTo( prmString ) );
		}
		catch( Exception ex )
		{
			// follow thru
		}
		ykmShowEncodingErrorDialog( prmString );
		throw new YKLookExceptionEncoding();
		//return "3f";  // '?'
	}
	static byte[] ykmLoadBytes( InputStream prmStream ) throws IOException
	{
		ArrayList aryBuf = new ArrayList();
		ArrayList arySiz = new ArrayList();
		byte[] src;
		byte[] dst;
		int idx,len,siz;

		len = 0;
		for( ;; )
		{
			src = new byte[8192];
			siz = prmStream.read(src);
			if( siz <= 0 )
				break;
			aryBuf.add( src );
			arySiz.add( new Integer( siz ) );
			len += siz;
		}
		prmStream.close();
		dst = new byte[ len ];
		len = 0;
		for( idx = 0; idx < aryBuf.size(); idx++ )
		{
			src = (byte[]) aryBuf.get( idx );
			siz = ((Integer)(arySiz.get( idx ))).intValue();
			System.arraycopy( src, 0, dst, len, siz );
			len += siz;
		}
		return dst;
	}
	Object ykmFindObjectFromId( String prmId )
	{
		char hdr = prmId.charAt(0);

		if( hdr == 'N' || hdr == 'n' || hdr == 'E' || hdr == 'e' )
			return null;

		return ykvObjects.get( new Integer( prmId ) );
	}

	void ykmAddNotification( YKLookSwingBase prmSource,
							YKLookNotificationIF prmReceiver, Object prmInfo )
	{
		ArrayList ary = (ArrayList) ykvNotification.get( prmSource );

		if( ary == null )
		{
			ary = new ArrayList();
			ykvNotification.put( prmSource, ary );
		}
		ary.add( new Object[] { prmReceiver, prmInfo } );
	}
	void ykmRemoveNotification( YKLookSwingBase prmSource,
								YKLookNotificationIF prmReceiver )
	{
		ArrayList list = (ArrayList) ykvNotification.get( prmSource );
		Object[]  ary;
		int       idx;

		if( list == null )
			return;

		for( idx = list.size() - 1; idx >= 0; idx-- )
		{
			ary = (Object[]) list.get( idx );
			if( ary[0] == prmReceiver )
				list.remove( idx );
		}
	}
	void ykmRemoveNotification( YKLookNotificationIF prmReceiver,
								Object prmInfo )
	{
		Iterator  it;
		ArrayList list;
		Object[]  ary;
		int       idx;

		it = ykvNotification.values().iterator();
		while( it.hasNext() )
		{
			list = (ArrayList) it.next();
			for( idx = list.size() - 1; idx >= 0; idx-- )
			{
				ary = (Object[]) list.get( idx );
				if( ary[0] == prmReceiver )
					if( ary[1].equals( prmInfo ) )
						list.remove( idx );
			}
		}
	}
	void ykmRemoveNotification( Object prmNotif )
	{
		Iterator  it;
		ArrayList list;
		Object[]  ary;
		int       idx;

		ykvNotification.remove( prmNotif );

		if( prmNotif instanceof YKLookNotificationIF )
		{
			it = ykvNotification.values().iterator();
			while( it.hasNext() )
			{
				list = (ArrayList) it.next();
				for( idx = list.size() - 1; idx >= 0; idx-- )
				{
					ary = (Object[]) list.get( idx );
					if( ary[0] == prmNotif )
						list.remove( idx );
				}
			}
		}
	}
	boolean ykmHasNotification( YKLookSwingBase prmSource )
	{
		ArrayList list = (ArrayList) ykvNotification.get( prmSource );

		if( list == null )
			return false;

		return list.size() > 0;
	}
	void ykmSendNotification( YKLookSwingBase prmSource, Object prmEvent )
	{
		ArrayList list = (ArrayList) ykvNotification.get( prmSource );
		Object[]  ary;
		int       idx;

		if( list == null )
			return;

		for( idx = list.size() - 1; idx >= 0; idx-- )
		{
			ary = (Object[]) list.get( idx );
			((YKLookNotificationIF) (ary[0])).
						ykmReceiveNotification( prmSource, prmEvent, ary[1] );
		}
	}

	boolean ykmCheckError()
	{
		if( ykvError == null )
			return false;

		JOptionPane.showMessageDialog( null, ykvError, "alert",
										JOptionPane.ERROR_MESSAGE );
		return true;
	}
	void ykmSendEventDialog( String prmInfo )
	{
		String cb;

		if( ykmCheckError() )
			return;

		try
		{
			cb = ykmDumpString( ykvDialogCB );

			SwingUtilities.invokeLater(
						new YKLookCorrespond( this,
								"YKLookEventDialog:0:" + ykvDialogCBframe +
												":" + cb +
												":" + prmInfo + ":end:" ) );
		}
		catch( YKLookExceptionEncoding ex )
		{
			ykvError = "illegal callback method name (Dialog)";
			ykmCheckError();
		}
	}
	void ykmSendEventAny( String prmSerializedEvent )
	{
		if( prmSerializedEvent == null )
			return;

		if( ykmCheckError() )
			return;

		ykmCorrespond( prmSerializedEvent );
	}

	URL ykmGetUrl( String prmUrl, String prmPath )
			throws MalformedURLException
	{
		URL url;

		if( prmUrl == null || prmUrl.length() <= 0 )
			url = ykvImpl.ykmGetDocumentBase();
		else
			url = new URL( prmUrl );

		if( prmPath != null && prmPath.length() > 0 )
			url = new URL( url, prmPath );

		return url;
	}
	Image ykmGetImageFromUrl( String prmUrl, String prmPath )
			throws MalformedURLException
	{
		return ykvImpl.ykmGetImage( ykmGetUrl( prmUrl, prmPath ) );
	}

	void ykmRemoveFrameAll()
	{
		Iterator it = ykvObjects.values().iterator();
		Object   obj;

		while( it.hasNext() )
		{
			obj = it.next();
			if( obj instanceof YKLookFrame )
			{
				((YKLookFrame) obj).ykvSelf.dispose();
				((YKLookFrame) obj).ykvSelf = null;
			}
		}
	}
	void ykmRemoveFrame( int prmFrameId )
	{
		Iterator it = ykvObjects.values().iterator();
		Object  obj;

		while( it.hasNext() )
		{
			obj = it.next();
			if( obj instanceof YKLookSwingBase )
			{
				if( ((YKLookSwingBase) obj).ykvFrame == prmFrameId )
				{
					it.remove();
					ykmRemoveNotification( obj );
				}
			}
		}
	}

	// id
	public boolean yk_setMainPanel( StringTokenizer prmStrTok )
	{
		Object obj = ykmFindObjectFromId( prmStrTok.nextToken() );
		Object frm = ykmFindObjectFromId( prmStrTok.nextToken() );
		JPanel pan;

		if( obj instanceof YKLookPanel )
		{
			if( frm instanceof YKLookFrame )
				pan = (JPanel) ((YKLookFrame) frm).ykvSelf.getContentPane();
			else
				pan = (JPanel) ykvImpl.ykmRootPaneContainer().getContentPane();

			((YKLookPanel) obj).ykmSetMainPanel( pan );
		}
		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}

	// className,id
	public boolean yk_new( StringTokenizer prmStrTok )
			throws ClassNotFoundException, InstantiationException,
					IllegalAccessException
	{
		String nam = prmStrTok.nextToken();
		String frm = prmStrTok.nextToken();
		String id  = prmStrTok.nextToken();

		ykmNewInstance( nam, frm, id );

		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}
	Object ykmNewInstance( String prmClassName, String prmFrame, String prmId )
			throws ClassNotFoundException, InstantiationException,
					IllegalAccessException
	{
		String  nam = "jp.co.yorozukotowariya.yklook." + prmClassName;
		int     frm = Integer.parseInt( prmFrame );
		Integer id  = new Integer( prmId );
		Class   cls;
		Object  gui;

		try
		{
			cls = Class.forName( nam );
		}
		catch( Exception ex )
		{
			ykmSetClassLoader( null );
			cls = ykvLoader.loadClass( nam );
		}
		gui = cls.newInstance();

		if( id.intValue() > 0 && ykvObjects.get( id ) == null )
		{
			ykvObjects.put( id, gui );
		}
		if( gui instanceof YKLookSwingBase )
		{
			((YKLookSwingBase)gui).ykvFrame  = frm;
			((YKLookSwingBase)gui).ykvId     = id;
			((YKLookSwingBase)gui).ykvCommon = this;
		}
		return gui;
	}

	// className,rawdata
	public boolean yk_loadClassFromFile( StringTokenizer prmStrTok )
			throws ClassNotFoundException, InstantiationException,
					IllegalAccessException
	{
		String nam = prmStrTok.nextToken();
		String dat = prmStrTok.nextToken();
		Class  cls;

		ykmSetClassLoader( dat );
		cls = ykvLoader.loadClass( nam );

		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}

	// button
	public boolean yk_setDefaultButton( StringTokenizer prmStrTok )
	{
		Object obj = ykmFindObjectFromId( prmStrTok.nextToken() );

		if( obj instanceof YKLookButton )
			ykvImpl.ykmRootPaneContainer().getRootPane().setDefaultButton(
									(JButton) (((YKLookButton) obj).ykvSelf) );

		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}

	public boolean yk_showMessageDialog( StringTokenizer prmStrTok )
	{
		JOptionPane pane;
		JDialog     dialog;
		String      res;

		pane = new JOptionPane( ykvDialogGui, ykvDialogMsgType,
								JOptionPane.DEFAULT_OPTION, ykvDialogIcon );
		dialog = pane.createDialog( null, ykvDialogTitle );
		dialog.show();

		if( ykvDialogCB == null )
			return true;

		if( pane.getValue() == null )
		{
			if( ykvDialogCBall != true )
				return true;

			res = "n:null";
		}
		else
		{
			res = "s:O";
		}
		ykmSendEventDialog( res );
		return true;
	}
	public boolean yk_showConfirmDialog( StringTokenizer prmStrTok )
	{
		int    idx;
		String res;

		idx = JOptionPane.showConfirmDialog( null, ykvDialogGui, ykvDialogTitle,
							ykvDialogOptType, ykvDialogMsgType, ykvDialogIcon );
		if( ykvDialogCB == null )
			return true;
		if( idx == JOptionPane.CLOSED_OPTION ||
			idx == JOptionPane.CANCEL_OPTION )
		{
			if( ykvDialogCBall != true )
				return true;
		}

		if( idx == JOptionPane.OK_OPTION || idx == JOptionPane.YES_OPTION )
		{
			switch( ykvDialogOptType )
			{
				case JOptionPane.YES_NO_OPTION       :
				case JOptionPane.YES_NO_CANCEL_OPTION: res = "s:Y"; break;
				case JOptionPane.OK_CANCEL_OPTION    :
				case JOptionPane.DEFAULT_OPTION      :
				default                              : res = "s:O"; break;
			}
		}
		else
		{
			switch( idx )
			{
				case JOptionPane.CANCEL_OPTION: res = "s:C"   ; break;
				case JOptionPane.NO_OPTION    : res = "s:N"   ; break;
				case JOptionPane.CLOSED_OPTION: res = "n:null"; break;
				default                       : res = "s:D"   ; break;
			}
		}
		ykmSendEventDialog( res );
		return true;
	}
	public boolean yk_showOptionDialog( StringTokenizer prmStrTok )
	{
		int    idx;
		String res = ":n:null";

		idx = JOptionPane.showOptionDialog( null, ykvDialogGui, ykvDialogTitle,
								JOptionPane.DEFAULT_OPTION, ykvDialogMsgType,
							ykvDialogIcon, ykvDialogOption, ykvDialogDefault );
		if( ykvDialogCB == null )
			return true;
		if( idx == JOptionPane.CLOSED_OPTION )
		{
			if( ykvDialogCBall != true )
				return true;

			res = "n:null" + res;
		}
		else
		{
			if( 0 <= idx && idx < ykvDialogOption.length )
			{
				try
				{
					res = ":S:" + ykmDecodeToHex(
										ykmEncodingTo( ykvDialogOption[idx] ) );
				}
				catch( Exception ex )
				{
					// follow thru
				}
			}
			res = "i:" + idx + res;
		}
		ykmSendEventDialog( res );
		return true;
	}
	public boolean yk_showInputDialog01( StringTokenizer prmStrTok )
	{
		String str,res;

		for( ;; )
		{
			str = (String) JOptionPane.showInputDialog( null, ykvDialogGui,
											ykvDialogTitle, ykvDialogMsgType,
											ykvDialogIcon, null, null );
			if( ykvDialogCB == null )
				return true;
			if( str == null )
			{
				if( ykvDialogCBall != true )
					return true;

				res = "n:null";
				break;
			}

			try
			{
				res = "S:" + ykmDecodeToHex( ykmEncodingTo( str ) );
				break;
			}
			catch( Exception ex )
			{
				// follow thru
			}
			ykmShowEncodingErrorDialog( str );
		}
		ykmSendEventDialog( res );
		return true;
	}
	public boolean yk_showInputDialog02( StringTokenizer prmStrTok )
	{
		String str, res;
		int    idx;

		for( ;; )
		{
			str = (String) JOptionPane.showInputDialog( null, ykvDialogGui,
											ykvDialogTitle,
											ykvDialogMsgType, ykvDialogIcon,
											ykvDialogOption, ykvDialogDefault );
			if( ykvDialogCB == null )
				return true;
			if( str == null )
			{
				if( ykvDialogCBall != true )
					return true;

				res = "n:null:n:null";
				break;
			}
			for( idx = 0; idx < ykvDialogOption.length; idx++ )
			{
				if( ykvDialogOption[idx].equals( str ) )
					break;
			}
			if( idx < ykvDialogOption.length )
				res = "i:" + idx;
			else
				res = "i:-1";
			try
			{
				res = res + ":S:" + ykmDecodeToHex( ykmEncodingTo( str ) );
				break;
			}
			catch( Exception ex )
			{
				// follow thru
			}
			ykmShowEncodingErrorDialog( str );
		}
		ykmSendEventDialog( res );
		return true;
	}
	public boolean yk_setDialogCB( StringTokenizer prmStrTok )
	{
		ykvDialogCB      = ykmNextString( prmStrTok );
		ykvDialogCBall   = prmStrTok.nextToken().equalsIgnoreCase( "all" );
		ykvDialogCBframe = Integer.parseInt( prmStrTok.nextToken() );

		if( ykvDialogCB != null )
			if( ykvDialogCB.length() == 0 )
				ykvDialogCB = null;

		return true;  // need scan for 'end'
	}
	public boolean yk_setDialogGui( StringTokenizer prmStrTok )
	{
		ykvDialogGui = ykmDecodeAny( prmStrTok );
		return true;  // need scan for 'end'
	}
	public boolean yk_setDialogTitle( StringTokenizer prmStrTok )
	{
		ykvDialogTitle = ykmNextString( prmStrTok );
		return true;  // need scan for 'end'
	}
	public boolean yk_setDialogMsgType( StringTokenizer prmStrTok )
	{
		switch( prmStrTok.nextToken().charAt(0) )
		{
			case 'e':
			case 'E': ykvDialogMsgType = JOptionPane.ERROR_MESSAGE; break;
			case 'w':
			case 'W': ykvDialogMsgType = JOptionPane.WARNING_MESSAGE; break;
			case 'q':
			case 'Q': ykvDialogMsgType = JOptionPane.QUESTION_MESSAGE; break;
			case 'p':
			case 'P': ykvDialogMsgType = JOptionPane.PLAIN_MESSAGE; break;
			case 'i':
			case 'I':
			default : ykvDialogMsgType = JOptionPane.INFORMATION_MESSAGE; break;
		}
		return true;  // need scan for 'end'
	}
	public boolean yk_setDialogOptType( StringTokenizer prmStrTok )
	{
		String tok = prmStrTok.nextToken().toLowerCase();

		if( tok.equals( "yn" ) )
		{
			ykvDialogOptType = JOptionPane.YES_NO_OPTION;
			return true;  // need scan for 'end'
		}
		if( tok.equals( "oc" ) )
		{
			ykvDialogOptType = JOptionPane.OK_CANCEL_OPTION;
			return true;  // need scan for 'end'
		}
		ykvDialogOptType = JOptionPane.YES_NO_CANCEL_OPTION;
		//ykvDialogOptType = JOptionPane.DEFAULT_OPTION;
		return true;  // need scan for 'end'
	}
	public boolean yk_setDialogIcon( StringTokenizer prmStrTok )
	{
		String      tok = prmStrTok.nextToken();
		YKLookImage img = (YKLookImage) ykmFindObjectFromId( tok );

		ykvDialogIcon = ( img == null ) ? null : img.ykvSelf;
		return true;  // need scan for 'end'
	}
	public boolean yk_setDialogOption( StringTokenizer prmStrTok )
	{
		int len = Integer.parseInt( prmStrTok.nextToken() );
		int idx;

		ykvDialogOption = new String[ len ];

		for( idx = 0; idx < len; idx++ )
		{
			ykvDialogOption[idx] = ykmNextString( prmStrTok );
		}
		return true;  // need scan for 'end'
	}
	public boolean yk_setDialogDefault( StringTokenizer prmStrTok )
	{
		String tok = prmStrTok.nextToken();
		int    idx;

		if( tok.charAt(0) == 'i' )
		{
			idx = Integer.parseInt( tok.substring(2) );
			if( 0 <= idx && idx < ykvDialogOption.length )
				ykvDialogDefault = ykvDialogOption[idx];
			else
				ykvDialogDefault = null;
		}
		else
		{
			ykvDialogDefault =
					ykmEncodingFrom( ykmDecodeFromHex( tok.substring(2) ) );
		}
		return true;  // need scan for 'end'
	}

	// path
	public boolean yk_nextDisplay( StringTokenizer prmStrTok )
			throws MalformedURLException, YKLookException
	{
		String path = ykmNextString( prmStrTok );
		String opt  = "?yks=" + ykvSelfId + "&yku=" + ykvUserId;

		ykvImpl.yk_nextDisplay( path, opt );

		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}

	// path
	public boolean yk_moreDisplay( StringTokenizer prmStrTok )
			throws MalformedURLException, YKLookException
	{
		String path   = ykmNextString( prmStrTok );
		String moreid = prmStrTok.nextToken();
		char   share  = prmStrTok.nextToken().charAt(0);
		String opt    = (share == 'T' || share == 't') ? ykvUserId : moreid;

		ykvImpl.yk_moreDisplay( path, "?yks=" + moreid + "&yku=" + opt );

		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}

	// url,file,target
	public boolean yk_showDocument( StringTokenizer prmStrTok )
			throws MalformedURLException, YKLookException
	{
		String strUrl    = ykmNextString( prmStrTok );
		String strFile   = ykmNextString( prmStrTok );
		String strTarget = ykmNextString( prmStrTok );

		ykvImpl.yk_showDocument( strUrl, strFile, strTarget );

		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}

	// message string
	public boolean yk_exit( StringTokenizer prmStrTok )
			throws YKLookException
	{
		String msg = ykmNextString( prmStrTok );

		ykvImpl.yk_exit( msg );

		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}

	// items...
	public boolean yk_adjustWidth( StringTokenizer prmStrTok )
	{
		int             len = Integer.parseInt( prmStrTok.nextToken() );
		int             idx;
		ArrayList       itm = new ArrayList();
		ArrayList       siz = new ArrayList();
		Dimension       dim;
		YKLookComponent co;
		JComponent      jc;
		Iterator        iti, its;
		int             width = 0;

		for( idx = 0; idx < len; idx++ )
		{
			co = (YKLookComponent) ykmFindObjectFromId( prmStrTok.nextToken() );
			jc = (JComponent) (co.ykvComponent);
			if( jc.isPreferredSizeSet() )
			{
				dim = jc.getPreferredSize();
				itm.add( jc  );
				siz.add( dim );
				if( width < dim.width )
					width = dim.width;
			}
		}
		iti = itm.iterator();
		its = siz.iterator();
		while( iti.hasNext() )
		{
			jc  = (JComponent) iti.next();
			dim = (Dimension)  its.next();
			dim.width = width;
			jc.setPreferredSize( dim );
		}
		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}

	// items...
	public boolean yk_adjustHeight( StringTokenizer prmStrTok )
	{
		int             len = Integer.parseInt( prmStrTok.nextToken() );
		int             idx;
		ArrayList       itm = new ArrayList();
		ArrayList       siz = new ArrayList();
		Dimension       dim;
		YKLookComponent co;
		JComponent      jc;
		Iterator        iti, its;
		int             height = 0;

		for( idx = 0; idx < len; idx++ )
		{
			co = (YKLookComponent) ykmFindObjectFromId( prmStrTok.nextToken() );
			jc = (JComponent) (co.ykvComponent);
			if( jc.isPreferredSizeSet() )
			{
				dim = jc.getPreferredSize();
				itm.add( jc  );
				siz.add( dim );
				if( height < dim.height )
					height = dim.height;
			}
		}
		iti = itm.iterator();
		its = siz.iterator();
		while( iti.hasNext() )
		{
			jc  = (JComponent) iti.next();
			dim = (Dimension)  its.next();
			dim.height = height;
			jc.setPreferredSize( dim );
		}
		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}


	static String ykmStack( Exception prmEx )
	{
		StringWriter sw = new StringWriter();
		PrintWriter  pw = new PrintWriter( sw );

		try
		{
			prmEx.printStackTrace( pw );
			pw.close();
			sw.close();
		}
		catch( Exception ex )
		{
			return "stack: " + ex.toString();
		}
		return sw.toString();
	}
	void ykmShowLog()
	{
		if( ykvLogBuf.length() < 1 )
			return;

		JOptionPane.showMessageDialog( null, ykvLogBuf.toString(), "log",
										JOptionPane.ERROR_MESSAGE );
		ykvLogBuf.setLength( 0 );
	}
	void ykmLog( String prmMsg )
	{
		ykvLogBuf.append( prmMsg );
	}
}

class YKLookCorrespond implements Runnable
{
	YKLookCommon ykvCommon;
	String       ykvAnswer;

	YKLookCorrespond( YKLookCommon prmCommon, String prmAnswer )
	{
		ykvCommon = prmCommon;
		ykvAnswer = prmAnswer;
	}

	public void run()
	{
		ykvCommon.ykmCorrespond( ykvAnswer );
	}
}

//
// end of program
//
