//
//  YKLookFrame
//
//  Copyright (c) 2009-2010 YorozuKotowariYa Ltd.
//
//
package jp.co.yorozukotowariya.yklook;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


class YKLookFrame extends YKLookReturnable implements WindowListener
{
	JFrame  ykvSelf;
	boolean ykvSetListener = false;

	YKLookFrame()
	{
		ykvSelf = new JFrame();
	}

	// button
	public boolean yk_setRootPanel( StringTokenizer prmStrTok )
	{
		Object obj = ykvCommon.ykmFindObjectFromId( prmStrTok.nextToken() );

		if( obj instanceof YKLookPanel )
		{
			((YKLookPanel) obj).ykmSetMainPanel(
											(JPanel) ykvSelf.getContentPane() );
		}
		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}

	// button
	public boolean yk_setDefaultButton( StringTokenizer prmStrTok )
	{
		Object obj = ykvCommon.ykmFindObjectFromId( prmStrTok.nextToken() );

		if( obj instanceof YKLookButton )
			ykvSelf.getRootPane().setDefaultButton(
									(JButton) (((YKLookButton) obj).ykvSelf) );

		return true;  // need scan for 'end'
		//return false;  // scan the next command immediately
	}

	public boolean yk_putClientProperty( StringTokenizer prmStrTok )
	{
		Object key = ykmEncodeProperty( prmStrTok.nextToken() );
		Object val = ykmEncodeProperty( prmStrTok.nextToken() );

		ykvSelf.getRootPane().putClientProperty( key, val );
		return true;  // need scan for 'end'
	}
	public boolean yk_setDefaultCloseOperation( StringTokenizer prmStrTok )
	{
		char chr = prmStrTok.nextToken().charAt(0);
		int  ope;

		ykvSelf.removeWindowListener( this );

		ykvCallback    = null;
		ykvSetListener = false;

		switch( chr )
		{
			case 'C': case 'c': ykvCallback = "yks_callback";
			case 'N': case 'n': ope = WindowConstants.DO_NOTHING_ON_CLOSE;
								break;
			case 'H': case 'h': ope = WindowConstants.HIDE_ON_CLOSE;
								break;
			default:
			case 'D': case 'd': ope = WindowConstants.DISPOSE_ON_CLOSE;
								break;
		}
		ykvSelf.setDefaultCloseOperation( ope );

		if( ykvCallback != null )
			ykvSelf.addWindowListener( this );

		return true;  // need scan for 'end'
	}
	public boolean yk_setIconImage( StringTokenizer prmStrTok )
	{
		Object obj = ykvCommon.ykmFindObjectFromId( prmStrTok.nextToken() );
		Image  img;

		if( obj instanceof YKLookImage )
			img = ((YKLookImage) obj).ykvSelf.getImage();
		else
			img = null;

		ykvSelf.setIconImage( img );
		return true;  // need scan for 'end'
	}
	public boolean yk_setResizable( StringTokenizer prmStrTok )
	{
		char chr = prmStrTok.nextToken().charAt(0);

		ykvSelf.setResizable( chr == 'T' || chr == 't' );
		return true;  // need scan for 'end'
	}
	public boolean yk_setTitle( StringTokenizer prmStrTok )
	{
		String str = ykvCommon.ykmNextString( prmStrTok );

		ykvSelf.setTitle( str );
		return true;  // need scan for 'end'
	}
	public boolean yk_setSize( StringTokenizer prmStrTok )
	{
		int       w   = YKLookCommon.ykmNextInt( prmStrTok );
		int       h   = YKLookCommon.ykmNextInt( prmStrTok );
		Dimension dim = ykvSelf.getSize();

		if( w == Integer.MIN_VALUE )
			w = dim.width;
		if( h == Integer.MIN_VALUE )
			h = dim.height;

		ykvSelf.setSize( w, h );
		return true;  // need scan for 'end'
	}
	public boolean yk_setLocation( StringTokenizer prmStrTok )
	{
		int   x = YKLookCommon.ykmNextInt( prmStrTok );
		int   y = YKLookCommon.ykmNextInt( prmStrTok );
		Point p = ykvSelf.getLocation();

		if( x == Integer.MIN_VALUE && y == Integer.MIN_VALUE )
			return true;  // need scan for 'end'

		if( x == Integer.MIN_VALUE )
			x = p.x;
		if( y == Integer.MIN_VALUE )
			y = p.y;

		ykvSelf.setLocation( x, y );
		return true;  // need scan for 'end'
	}
	public boolean yk_dispose( StringTokenizer prmStrTok )
	{
		ykvSelf.dispose();
		ykvSelf = null;
		ykvCommon.ykmRemoveFrame( ykvFrame );
		return true;  // need scan for 'end'
	}
	public boolean yk_pack( StringTokenizer prmStrTok )
	{
		ykvSelf.pack();
		return true;  // need scan for 'end'
	}
	public boolean yk_hide( StringTokenizer prmStrTok )
	{
		ykvSelf.hide();
		return true;  // need scan for 'end'
	}
	public boolean yk_show( StringTokenizer prmStrTok )
	{
		ykvSelf.show();
		return true;  // need scan for 'end'
	}
	public boolean yk_showWithinScreen( StringTokenizer prmStrTok )
	{
		int x = YKLookCommon.ykmNextInt( prmStrTok );
		int y = YKLookCommon.ykmNextInt( prmStrTok );

		ykmShowWithinScreen( x, y );
		return true;  // need scan for 'end'
	}
	public boolean yk_showWithinScreenLater( StringTokenizer prmStrTok )
	{
		int x = YKLookCommon.ykmNextInt( prmStrTok );
		int y = YKLookCommon.ykmNextInt( prmStrTok );

		ykmShowWithinScreenLater( x, y );
		return true;  // need scan for 'end'
	}
	public boolean yk_setListener( StringTokenizer prmStrTok )
	{
		ykmSetCallback( prmStrTok );

		ykvSelf.removeWindowListener( this );

		if( ykvCallback != null )
		{
			ykvSetListener = true;
			ykvSelf.addWindowListener( this );
		}
		return true;  // need scan for 'end'
	}

	public void windowOpened( WindowEvent prmEvent ) { /* nothing */ }
	public void windowClosed( WindowEvent prmEvent ) { /* nothing */ }
	public void windowClosing( WindowEvent prmEvent )
	{
		String hdr = ykmMakeEventHeader( "YKLookEventFrame" );

		if( hdr == null )
			return;

		SwingUtilities.invokeLater(
						new YKLookCorrespond( ykvCommon,
												hdr + ":s:Closing:end:" ) );
	}
	public void windowActivated( WindowEvent prmEvent )
	{
		ykmMakeEvent( "Activated" );
	}
	public void windowDeactivated( WindowEvent prmEvent )
	{
		ykmMakeEvent( "Deactivated" );
	}
	public void windowIconified( WindowEvent prmEvent )
	{
		ykmMakeEvent( "Iconified" );
	}
	public void windowDeiconified( WindowEvent prmEvent )
	{
		ykmMakeEvent( "Deiconified" );
	}
	void ykmMakeEvent( String prmAnswer )
	{
		String hdr = ykmMakeEventHeader( "YKLookEventFrame" );

		if( hdr == null )
			return;

		if( ykvSetListener )
			ykvCommon.ykmSendEventAny( hdr + ":s:" + prmAnswer + ":end:" );
	}

	void ykmShowWithinScreenLater( int prmX, int prmY )
	{
		SwingUtilities.invokeLater(
							new YKLookShowWithinScreen( this, prmX, prmY ) );
	}
	void ykmShowWithinScreen( int prmX, int prmY )
	{
		Dimension dim  = Toolkit.getDefaultToolkit().getScreenSize();
		Rectangle scr  = new Rectangle( dim );
		Rectangle rect = ykvSelf.getBounds();
		Rectangle wrk;

		if( ! scr.contains( rect ) )
		{
			if( rect.width > scr.width )
				rect.width = scr.width;
			if( rect.height > scr.height )
				rect.height = scr.height;
			if( rect.x < 0 )
				rect.x = 0;
			if( rect.y < 0 )
				rect.y = 0;
			if( rect.x > scr.width )
				rect.x = scr.width;
			if( rect.y > scr.height )
				rect.y = scr.height;
			wrk = scr.union( rect );
			if( wrk.width > scr.width )
				rect.x -= wrk.width - scr.width;
			if( wrk.height > scr.height )
				rect.y -= wrk.height - scr.height;
		}
		if( 0 <= prmX && prmX <= 100 )
			rect.x = (scr.width - rect.width) * prmX / 100;

		if( 0 <= prmY && prmY <= 100 )
			rect.y = (scr.height - rect.height) * prmY / 100;

		ykvSelf.setBounds( rect );
		ykvSelf.show();
	}
}

class YKLookShowWithinScreen implements Runnable
{
	YKLookFrame ykvFrame;
	int         ykvX;
	int         ykvY;

	YKLookShowWithinScreen( YKLookFrame prmFrame, int prmX, int prmY )
	{
		ykvFrame = prmFrame;
		ykvX     = prmX;
		ykvY     = prmY;
	}

	public void run()
	{
		ykvFrame.ykmShowWithinScreen( ykvX, ykvY );
	}
}


//
// end of program
//
