//
//  YKLookStandAlone
//
//  Copyright (c) 2009-2010 YorozuKotowariYa Ltd.
//
//
package jp.co.yorozukotowariya.yklook;

import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class YKLookStandAlone implements YKLookCommonIF, WindowListener
{
	static YKLookStandAlone ykvMain;

	BufferedReader ykvReader;
	BufferedWriter ykvWriter;
	YKLookCommon   ykvCommon;
	YKLookFrame    ykvFrame = null;
	HashMap        ykvParam = new HashMap();

	public static void main( String[] args ) throws IOException
	{
		if( args.length == 2 )
		{
			if( args[0].startsWith( "yks=" ) && args[1].startsWith( "yku=" ) )
			{
				if( args[0].length() >= 13 && args[1].length() >= 13 )
				{
					ykvMain = new YKLookStandAlone();
					ykvMain.ykmSetup();
					ykvMain.ykmGetParamFromStdin();
					ykvMain.ykmInit(args[0].substring(4),args[1].substring(4));
					return;
				}
			}
		}
		YKLookInfo.ykmVersionDisplay();
	}
	void ykmSetup()
	{
		ykvReader = new BufferedReader( new  InputStreamReader( System.in  ) );
		ykvWriter = new BufferedWriter( new OutputStreamWriter( System.out ) );
	}
	void ykmGetParamFromStdin() throws IOException
	{
		String str;
		int    idx;

		ykvReader.readLine();  // ignore (first line means data size)
		for( ;; )
		{
			str = ykvReader.readLine();
			if( str == null )
				break;
			if( str.equalsIgnoreCase( "yk_end" ) )
				break;

			idx = str.indexOf( '=' );
			if( idx < 0 )
				continue;

			ykvParam.put( str.substring(0,idx), str.substring(idx+1) );
		}
	}
	void ykmInit( String prmSelfId, String prmUserId )
	{
		String frm = (String) ykvParam.get( "YKLook_nearFrame" );
		String msg;

		ykvCommon = new YKLookCommon( prmSelfId, prmUserId, this );

		try
		{
			ykvFrame = (YKLookFrame)
						ykvCommon.ykmNewInstance( "YKLookFrame", "0", frm );
		}
		catch( Exception ex )
		{
			msg = "Error (" + ex.toString() + ")\n\n" +
					YKLookCommon.ykmStack(ex);

			JOptionPane.showMessageDialog( null, msg, "alert",
											JOptionPane.ERROR_MESSAGE );
			return;
		}
		ykvCommon.ykmSetEncoding();
		ykvCommon.ykmSetLookAndFeel();
		ykvCommon.ykmCorrespond( null );

		if( ykvCommon.ykvObjects.size() <= 0 )
		{
			ykvFrame.ykvSelf.getContentPane().
									add(new JLabel( YKLookInfo.ykmInfo()[0] ));
		}
		ykvCommon.ykmShowLog();

		ykvFrame.ykvSelf.
				setDefaultCloseOperation( WindowConstants.DO_NOTHING_ON_CLOSE );
		ykvFrame.ykvSelf.removeWindowListener( ykvFrame );
		ykvFrame.ykvSelf.addWindowListener( this );
		ykvFrame.ykmShowWithinScreenLater( Integer.MIN_VALUE,
											Integer.MIN_VALUE );
	}

	public void windowOpened( WindowEvent prmEvent ) { /* nothing */ }
	public void windowClosed( WindowEvent prmEvent ) { /* nothing */ }
	public void windowClosing( WindowEvent prmEvent )
	{
		String se = ykmMakeEvent("Closing");

		if( se != null )
		{
			SwingUtilities.invokeLater(
						new YKLookCorrespond( ykvCommon, se ) );
		}
	}
	public void windowActivated( WindowEvent prmEvent )
	{
		// ykvCommon.ykmSendEventAny( ykmMakeEvent("Activated") );
	}
	public void windowDeactivated( WindowEvent prmEvent )
	{
		// ykvCommon.ykmSendEventAny( ykmMakeEvent("Deactivated") );
	}
	public void windowIconified( WindowEvent prmEvent )
	{
		// ykvCommon.ykmSendEventAny( ykmMakeEvent("Iconified") );
	}
	public void windowDeiconified( WindowEvent prmEvent )
	{
		// ykvCommon.ykmSendEventAny( ykmMakeEvent("Deiconified") );
	}
	String ykmMakeEvent( String prmAnswer )
	{
		String str;

		try
		{
			str = ykvCommon.ykmDumpString( "yks_callback_near" );
			return "YKLookEventFrame:0:0:" + str + ":s:"+ prmAnswer +":end:";
		}
		catch( YKLookExceptionEncoding ex )
		{
			// impossible to enter here
		}
		return null;
	}

	public String ykmGetParameter( String prmKey )   // YKLookCommonIF
	{
		return (String) ykvParam.get( prmKey );
	}

	public URL ykmGetDocumentBase()         // YKLookCommonIF
			throws MalformedURLException
	{
		String cwd = (String) ykvParam.get( "YKLook_cwd" );

		return new URL( "file:" + cwd );
	}

	public RootPaneContainer ykmRootPaneContainer()  // YKLookCommonIF
	{
		return ykvFrame.ykvSelf;
	}

	public Image ykmGetImage( URL prmUrl )  // YKLookCommonIF
			throws MalformedURLException
	{
		return Toolkit.getDefaultToolkit().getImage( prmUrl );
	}

	public InputStream ykmGetCodeAsStream( String prmPath )  // YKLookCommonIF
			throws IOException, YKLookException
	{
		String str = (String) ykvParam.get( "YKLook_nearPath" );

		if( str != null && str.length() > 0 )
			prmPath = str + "/" + prmPath;

		return new FileInputStream( prmPath );
	}

	public String ykmCommunicate( String prmText )  // YKLookCommonIF
			throws IOException, YKLookException
	{
		// String msg;

		try
		{
			ykvWriter.write( String.valueOf( prmText.length() )  + "\n" );
			ykvWriter.write( prmText );
			ykvWriter.flush();

			ykvReader.readLine();  // ignore (first line means data size)

			return ykvCommon.ykmRecvAnswer( ykvReader );
		}
		catch( Exception ex )  // fatal error. never retry
		{
			//msg = "Error\n" + ex.toString() + "\n\n" +
			//				YKLookCommon.ykmStack(ex);
		}
		// JOptionPane.showMessageDialog( null, msg, "alert",
		//							JOptionPane.ERROR_MESSAGE );
		System.exit( 1 );
		return null;  // dummy for compiler
	}

	public void yk_nextDisplay( String prmPath, String prmOpt )
			throws MalformedURLException, YKLookException     // YKLookCommonIF
	{
		// nothing
	}
	public void yk_moreDisplay( String prmPath, String prmOpt )
			throws MalformedURLException, YKLookException     // YKLookCommonIF
	{
		// nothing
	}

	public void yk_showDocument( String prmUrl,String prmFile,String prmTarget )
			throws MalformedURLException, YKLookException     // YKLookCommonIF
	{
		// nothing
	}

	public void yk_exit( String prmMsg )  // YKLookCommonIF
			throws YKLookException
	{
		// nothing
	}
}


//
// end of program
//
